<?php
	require_once "lib/bd.php";

	class arxiu
	{
		var $bd = "";
		var $sub_id = "";
		var $lli_id = "";
		var $apa_id = "";
		
		var $nom = "";
		var $directori = "";
		var $capsalera = "";
		var $peu = "";
		var $punter;

		function obre($parametres)
		{
			$this->punter = fopen($this->directori . "/" . $this->nom, $parametres);
		}
		
		function tanca()
		{
			fclose($this->punter);
		}
		
		function crea_arxiu($bd, $sub_id, $lli_id = "", $apa_id = "")
		{
			$this->bd = $bd;
			$this->sub_id = $sub_id;
			$this->lli_id = $lli_id;
			$this->apa_id = $apa_id;
			
			$capsalera_text = $this->obtenir_arxiu($this->capsalera);
			$cos_text = $this->obtenir_arxiu($this->cos);
			$peu_text = $this->obtenir_arxiu($this->peu);
			
			$arxiu_text = $capsalera_text . $cos_text . $peu_text;
			
			$operacio = $this->graba_text($arxiu_text);

			return $operacio;
		}
		
		function obtenir_arxiu($arxiu)
		{
			if (file_exists($arxiu)) { $text = implode("", file($arxiu)); }
			else { $text = ""; }
			return $text;
		}
		
		function graba_text($text)
		{
			$text = $this->filtra_text($text);
			$this->obre("w+");
			fwrite($this->punter, $text);
			$this->tanca();
		}

		function filtra_text($text)
		{
			$bd = $this->bd;
			$sub_id = $this->sub_id;
			$lli_id = $this->lli_id;
			$apa_id = $this->apa_id;

			if (trim($lli_id) != "" && is_numeric($lli_id))
			{
				$consulta = "SELECT * FROM llibres WHERE LLI_id = $lli_id";
				$resultats_llibres = $bd->fes_consulta($consulta);
				if (mysql_num_rows($resultats_llibres) > 0)
				{
					$row = mysql_fetch_assoc($resultats_llibres);
					$titol_llibre = $row["LLI_titol"];
					$objectius_llibre = $row["LLI_objectius"];
				} else { $titol_llibre = ""; $objectius_llibre = ""; }
				/*$consulta = "SELECT * FROM apartats WHERE APA_id IN (SELECT APACOL_id WHERE )";
				$resultats_llibres = $bd->fes_consulta($consulta);
				if (mysql_num_rows($resultats_llibres) > 0)
				{
					$row = mysql_fetch_assoc($resultats_llibres);
					$titol_llibre = $row["LLI_titol"];
				} else { $nom_apartat = ""; }*/
			} else { $titol_llibre = ""; $objectius_llibre = ""; }
			if (trim($sub_id) != "" && is_numeric($sub_id))
			{
				$consulta = "SELECT * FROM subcolleccions WHERE SUB_id = $sub_id";
				$resultats_subcolleccions = $bd->fes_consulta($consulta);
				if (mysql_num_rows($resultats_subcolleccions) > 0)
				{
					$row = mysql_fetch_assoc($resultats_subcolleccions);
					$titol_subcolleccio = $row["SUB_titol"];
				} else { $titol_subcolleccio = ""; }

				$consulta = "SELECT * FROM llibres WHERE LLI_subcolleccio = $sub_id ORDER BY LLI_titol";
				$resultats_llibres = $bd->fes_consulta($consulta);
				if (mysql_num_rows($resultats_llibres) > 0)
				{
					$row = mysql_fetch_assoc($resultats_llibres);
					$primer_id_llibre = $row["LLI_id"];
				} else { $primer_id_llibre = ""; }
				
			} else { $titol_subcolleccio = ""; $primer_id_llibre = ""; $nom_apartat = ""; }
			if (trim($apa_id) != "" && is_numeric($apa_id))
			{
				$consulta = "SELECT APA_nom FROM apartats WHERE APA_id = $apa_id";
				$resultats_apartats = $bd->fes_consulta($consulta);
				if (mysql_num_rows($resultats_apartats) > 0)
				{
					$row = mysql_fetch_assoc($resultats_apartats);
					$nom_apartat = $row["APA_nom"];
				} else { $nom_apartat = ""; }
			} else { $nom_apartat = ""; }
			
			$etiquetes = Array(
								"[TITOL_LLIBRE]" => $titol_llibre,
								"[TITOL_SUBCOLLECCIO]" => trim($titol_subcolleccio),
								"[LLIBRE_PRIMER_ID]" => $primer_id_llibre,
								"[SUBCOLLECCIO_IMATGE]" => $this->subcolleccio_imatge(),
								"[MENU_LLIBRES]" => $this->menu_llibres(),
								"[OBJECTIUS_LLIBRE]" => $objectius_llibre,
								"[LLIBRE_IMATGE_PORTADA]" => $this->imatge_llibre("portada"),
								"[LLIBRE_IMATGE_TRIPA]" => $this->imatge_llibre("tripa"),
								"[NOM_APARTAT]" => $nom_apartat,
								"[LLISTAT_SUBCOLLECCIONS]" => $this->llistat_subcolleccions(),
								);

			foreach($etiquetes as $etiqueta => $valor)
			{
				if ($etiqueta != "")
				{
					$text = str_replace($etiqueta, $valor, $text);
				}
			}

			//Doble passada (perque menu_llibres() genera tambe etiquetes):
			foreach($etiquetes as $etiqueta => $valor)
			{
				if ($etiqueta != "")
				{
					$text = str_replace($etiqueta, $valor, $text);
				}
			}
			
			return $text;
		}

		function llistat_subcolleccions()
		{
			$llistat = "";
			$apa_id = $this->apa_id;
			if (trim($apa_id) == "") { return ""; }
			
			$bd = $this->bd;

			$consulta = "SELECT * FROM subcolleccions JOIN apartats_subcolleccions ON APACOL_id = $apa_id AND SUB_id = APACOL_subcolleccio AND SUB_visible != 0 ORDER BY APACOL_ordre";
			$resultats = $bd->fes_consulta($consulta);

			$par_o_impar = "impar";
			$text = "";
			while ($row = mysql_fetch_assoc($resultats))
			{
				$id_subcolleccio = $row["SUB_id"];
				$imatge_subcolleccio = $this->subcolleccio_imatge($id_subcolleccio); 
				//echo "$id_subcolleccio=>$imatge_subcolleccio<br>";
				$titol_subcolleccio = $row["SUB_titol"];
				$subcolleccio_text_amb_salt = str_replace('[SALT]', '</TD><TD width="45"><img src="../images/trans.gif" width="45"></TD><TD width="281">', $row["SUB_text"]);
				$par_o_impar = ($par_o_impar == "par") ? "impar" : "par";
				$opcio_veure = $row["SUB_opcio_ver_coleccion"];
				$veure_colleccio = ($opcio_veure) ? '<br><br><A HREF="javascript:MM_openBrWindow(\'subcolleccions/'.$id_subcolleccio.'/index.html?apartat=[NOM_APARTAT]\',\'\',\'width=780,height=580\');"><img src="../images/ver.gif" border=0></A>' : '';
				if ($opcio_veure)
				{
					$text = str_replace("[LINK_SUBCOLLECCIO]", "javascript:MM_openBrWindow('subcolleccions/[ID_SUBCOLLECCIO]/index.html?apartat=[NOM_APARTAT]','','width=780,height=580');", $text);
				} else { $text = str_replace("[LINK_SUBCOLLECCIO]", "", $text); } 
				$text .= implode("", file("lib/html/apartat_cos_repetir.html"));
				$text = str_replace("[ID_SUBCOLLECCIO]", $id_subcolleccio, $text);
				$text = str_replace("[IMATGE_SUBCOLLECCIO]", $imatge_subcolleccio, $text);
				$text = str_replace("[TITOL_SUBCOLLECCIO]", $titol_subcolleccio, $text);
				$text = str_replace("[SUBCOLLECCIO_TEXT_AMB_SALT]", $subcolleccio_text_amb_salt, $text);
				$text = str_replace("[PAR_O_IMPAR]", $par_o_impar, $text);
				$text = str_replace("[VEURE_COLLECCIO]", $veure_colleccio, $text);
				
			}

			$llistat = $text;
			return $llistat;
		}
		
		function subcolleccio_imatge($sub_id = "")
		{
			if (trim($sub_id) == "") { $sub_id = $this->sub_id; }
			$extensions = Array("jpg", "gif", "png");
			$arxiu = "";
			foreach ($extensions as $extensio)
			{
				if (file_exists("generats/subcolleccions/$sub_id/images/$sub_id.$extensio"))
				{
					$arxiu = "$sub_id.$extensio";
					break;
				} 
			}
			return $arxiu;
		}
		
		function menu_llibres()
		{
			$bd = $this->bd;	
			$sub_id = $this->sub_id;
			$links ="";
			$consulta = "SELECT * FROM llibres WHERE LLI_subcolleccio = $sub_id ORDER BY LLI_subapartat, LLI_ordre, LLI_titol";
			$resultats = $bd->fes_consulta($consulta);
			
			$subapartat = "";
			while ($row = mysql_fetch_assoc($resultats))
			{
				if ($subapartat != $row["LLI_subapartat"] && trim($row["LLI_subapartat"]) != "")
				{
					$subapartat = $row["LLI_subapartat"];
					$links .= "<br><b>$subapartat</b><br>";
				}
				$id_llibre = $row["LLI_id"];
				$titol_llibre = $row["LLI_titol"];
				$links .= '<a href="' . $id_llibre . '.html" target="eso" border=0>' . $titol_llibre . '</a><br>';
			}
			
			return $links;
		}
		
		function imatge_llibre($part)
		{
			$sub_id = $this->sub_id;
			$lli_id = $this->lli_id;
			$extensions = Array("jpg", "gif", "png");
			$arxiu = "";
			foreach ($extensions as $extensio)
			{
				if (file_exists("generats/subcolleccions/$sub_id/images/".$lli_id."_$part.$extensio"))
				{
					$arxiu = "$lli_id"."_"."$part.$extensio";
					break;
				} 
			}
			return $arxiu;
		}
	}
?>